Bug 1288858 - Review Request: lodash - A JavaScript utility library
Review Request: lodash - A JavaScript utility library
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Piotr Popieluch
Fedora Extras Quality Assurance
:
Depends On:
Blocks: nodejs-reviews
  Show dependency treegraph
 
Reported: 2015-12-06 12:11 EST by Tom Hughes
Modified: 2015-12-14 15:37 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-14 15:37:29 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
piotr1212: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Tom Hughes 2015-12-06 12:11:52 EST
Spec URL: http://tomh.fedorapeople.org//lodash.spec
SRPM URL: http://tomh.fedorapeople.org//lodash-3.10.1-1.fc23.src.rpm

Description:
A JavaScript utility library delivering consistency,
modularity, performance, & extras.
Comment 1 Tom Hughes 2015-12-06 12:12:58 EST
Note that this is intended to replace the current nodejs-lodash, nodejs-lodash-cli and nodejs-lodash-node packages, which will be retired.
Comment 2 Upstream Release Monitoring 2015-12-06 12:21:48 EST
tomh's scratch build of lodash-3.10.1-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12089248
Comment 3 Piotr Popieluch 2015-12-09 05:26:03 EST
➜  rpmbuild  fedora-review -b 1288858                
INFO: Processing bugzilla bug: 1288858
INFO: Getting .spec and .srpm Urls from : 1288858
INFO:   --> SRPM url: http://tomh.fedorapeople.org//lodash-3.10.1-1.fc23.src.rpm
INFO:   --> Spec url: http://tomh.fedorapeople.org//lodash.spec
INFO: Using review directory: /home/piotr/rpmbuild/1288858-lodash
INFO: Downloading .spec and .srpm files
error: lua script failed: [string "<lua>"]:14: attempt to index a nil value
error: line 126: 
ERROR: "Can't parse specfile: can't parse specfile\n" (logs in /home/piotr/.cache/fedora-review.log)
Comment 4 Piotr Popieluch 2015-12-09 05:40:39 EST
Building it directly with rpmbuild gives other result, here it seems that the symlink to lodash-cli/node_modules/uglify-js is missing:



 ~/rpmbuild/BUILD/lodash-3.10.1
+ /usr/bin/node ./node_modules/lodash-cli/bin/lodash modern -o ./lodash.js
Compressing lodash.min using the Closure Compiler (simple)...
Done. Size: 18548 bytes.
Compressing lodash.min using the Closure Compiler (advanced)...
Done. Size: 18549 bytes.

Error: Cannot find module 'uglify-js'
    at Function.Module._resolveFilename (module.js:338:15)
    at Function.Module._load (module.js:280:25)
    at Module.require (module.js:364:17)
    at require (module.js:380:17)
    at Minify.uglify (/home/piotr/rpmbuild/BUILD/lodash-3.10.1/node_modules/lodash-cli/lib/minify.js:433:18)
    at Minify.onClosureAdvancedGzip (/home/piotr/rpmbuild/BUILD/lodash-3.10.1/node_modules/lodash-cli/lib/minify.js:558:10)
    at Gzip.onEnd (zlib.js:167:5)
    at Gzip.emit (events.js:117:20)
    at _stream_readable.js:944:16
    at process._tickCallback (node.js:442:13)
error: Bad exit status from /var/tmp/rpm-tmp.ZkQmDu (%build)
Comment 5 Tom Hughes 2015-12-09 05:46:25 EST
What version of nodejs-packaging do you have? I suspect you only have -7-4 which means it won't resolve "^2.4.13" for uglify-js as it's multi-version.
Comment 6 Piotr Popieluch 2015-12-09 06:50:11 EST
Yes, that was it, updated to 7.5 from Rawhide, now it builds
Maybe you could add version to BR 'nodejs-packaging >= 7.5'?
Comment 7 Tom Hughes 2015-12-10 03:30:30 EST
Do you need anything more from me to progress this? I can't reproduce the fedora-review failure by the way - it took eight hours due to the current f-r performance issues but it did complete in the end.
Comment 8 Piotr Popieluch 2015-12-10 04:05:55 EST
It did finish yesterday after a long time with a lot of warnings. Didn't have time to finish the review. I will take a look this evening.
Comment 9 Piotr Popieluch 2015-12-13 07:04:51 EST
It took fedora-review 20 hours to complete :S

See comments inline. Most important:
- some subpackages are missing license
- packages are being obsoleted but there is no new provide (see rpmlint part)


The review is too long to fit as one comment in bugzilla.
Comment 10 Piotr Popieluch 2015-12-13 07:05:15 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: Cannot find license.jst in rpm(s)
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text


license files missing in subpackages, please add license to these packages
js-lodash
nodejs-lodash
nodejs-lodash-cli
nodejs-lodash-compat
nodejs-lodash-node



- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 2641920 bytes in 259 files.
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


Think we can ignore this, as this is a lot of packages thats why the size is large



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[!]: License file installed when any subpackage combination is installed.


As above, please add license file to all subpackages



[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source2:
     https://raw.githubusercontent.com/lodash/lodash/3.10.1-npm/package.json
     #/lodash-package.json, Source3:
     https://raw.githubusercontent.com/lodash/lodash-
     compat/3.10.1-npm/package.json#/lodash-compat-package.json, Source4:
     https://raw.githubusercontent.com/lodash/lodash-
     node/3.10.1/package.json#/lodash-node-package.json
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags


I think we can ignore this, urls seem fine



[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in js-
     lodash , nodejs-lodash , nodejs-lodash-compat , nodejs-lodash-node ,
     nodejs-lodash-cli , nodejs-lodash-add , nodejs-lodash-after , nodejs-
     lodash-arraycopy , nodejs-lodash-arrayeach , nodejs-lodash-arrayevery
     , nodejs-lodash-arrayfilter , nodejs-lodash-arraymap , nodejs-lodash-
     ary , nodejs-lodash-assign , nodejs-lodash-at , nodejs-lodash-attempt
     , nodejs-lodash-baseassign , nodejs-lodash-baseat , nodejs-lodash-
     basecallback , nodejs-lodash-baseclone , nodejs-lodash-
     basecompareascending , nodejs-lodash-basecopy , nodejs-lodash-
     basecreate , nodejs-lodash-basedelay , nodejs-lodash-basedifference ,
     nodejs-lodash-baseeach , nodejs-lodash-baseeachright , nodejs-lodash-
     basefilter , nodejs-lodash-basefind , nodejs-lodash-basefindindex ,
     nodejs-lodash-baseflatten , nodejs-lodash-basefor , nodejs-lodash-
     baseforright , nodejs-lodash-basefunctions , nodejs-lodash-baseget ,
     nodejs-lodash-baseindexof , nodejs-lodash-baseisequal , nodejs-lodash-
     baseismatch , nodejs-lodash-basematches , nodejs-lodash-
     basematchesproperty , nodejs-lodash-basepullat , nodejs-lodash-
     baserandom , nodejs-lodash-basereduce , nodejs-lodash-baseslice ,
     nodejs-lodash-basesortby , nodejs-lodash-basesortbyorder , nodejs-
     lodash-basetostring , nodejs-lodash-baseuniq , nodejs-lodash-
     basevalues , nodejs-lodash-before , nodejs-lodash-binaryindex ,
     nodejs-lodash-binaryindexby , nodejs-lodash-bind , nodejs-lodash-
     bindall , nodejs-lodash-bindcallback , nodejs-lodash-bindkey , nodejs-
     lodash-cacheindexof , nodejs-lodash-callback , nodejs-lodash-camelcase
     , nodejs-lodash-capitalize , nodejs-lodash-ceil , nodejs-lodash-
     charsleftindex , nodejs-lodash-charsrightindex , nodejs-lodash-chunk ,
     nodejs-lodash-clone , nodejs-lodash-clonedeep , nodejs-lodash-compact
     , nodejs-lodash-constant , nodejs-lodash-countby , nodejs-lodash-
     create , nodejs-lodash-createaggregator , nodejs-lodash-createassigner
     , nodejs-lodash-createcache , nodejs-lodash-createcompounder , nodejs-
     lodash-createpadding , nodejs-lodash-createwrapper , nodejs-lodash-
     curry , nodejs-lodash-curryright , nodejs-lodash-debounce , nodejs-
     lodash-deburr , nodejs-lodash-defaults , nodejs-lodash-defaultsdeep ,
     nodejs-lodash-defer , nodejs-lodash-delay , nodejs-lodash-difference ,
     nodejs-lodash-drop , nodejs-lodash-dropright , nodejs-lodash-
     droprightwhile , nodejs-lodash-dropwhile , nodejs-lodash-endswith ,
     nodejs-lodash-escape , nodejs-lodash-escaperegexp , nodejs-lodash-
     every , nodejs-lodash-fill , nodejs-lodash-filter , nodejs-lodash-find
     , nodejs-lodash-findindex , nodejs-lodash-findkey , nodejs-lodash-
     findlast , nodejs-lodash-findlastindex , nodejs-lodash-findlastkey ,
     nodejs-lodash-findwhere , nodejs-lodash-first , nodejs-lodash-flatten
     , nodejs-lodash-flattendeep , nodejs-lodash-floor , nodejs-lodash-flow
     , nodejs-lodash-flowright , nodejs-lodash-foreach , nodejs-lodash-
     foreachright , nodejs-lodash-forin , nodejs-lodash-forinright ,
     nodejs-lodash-forown , nodejs-lodash-forownright , nodejs-lodash-
     functions , nodejs-lodash-get , nodejs-lodash-getnative , nodejs-
     lodash-groupby , nodejs-lodash-gt , nodejs-lodash-gte , nodejs-lodash-
     has , nodejs-lodash-identity , nodejs-lodash-includes , nodejs-lodash-
     indexby , nodejs-lodash-indexof , nodejs-lodash-initial , nodejs-
     lodash-inrange , nodejs-lodash-intersection , nodejs-lodash-invert ,
     nodejs-lodash-invoke , nodejs-lodash-invokepath , nodejs-lodash-
     isarguments , nodejs-lodash-isarray , nodejs-lodash-isboolean ,
     nodejs-lodash-isdate , nodejs-lodash-iselement , nodejs-lodash-isempty
     , nodejs-lodash-isequal , nodejs-lodash-iserror , nodejs-lodash-
     isfinite , nodejs-lodash-isfunction , nodejs-lodash-isiterateecall ,
     nodejs-lodash-ismatch , nodejs-lodash-isnan , nodejs-lodash-isnative ,
     nodejs-lodash-isnull , nodejs-lodash-isnumber , nodejs-lodash-isobject
     , nodejs-lodash-isplainobject , nodejs-lodash-isregexp , nodejs-
     lodash-isstring , nodejs-lodash-istypedarray , nodejs-lodash-
     isundefined , nodejs-lodash-kebabcase , nodejs-lodash-keys , nodejs-
     lodash-keysin , nodejs-lodash-last , nodejs-lodash-lastindexof ,
     nodejs-lodash-lt , nodejs-lodash-lte , nodejs-lodash-map , nodejs-
     lodash-mapkeys , nodejs-lodash-mapvalues , nodejs-lodash-matches ,
     nodejs-lodash-matchesproperty , nodejs-lodash-max , nodejs-lodash-
     memoize , nodejs-lodash-merge , nodejs-lodash-method , nodejs-lodash-
     methodof , nodejs-lodash-min , nodejs-lodash-mixin , nodejs-lodash-
     modargs , nodejs-lodash-negate , nodejs-lodash-noop , nodejs-lodash-
     now , nodejs-lodash-omit , nodejs-lodash-once , nodejs-lodash-pad ,
     nodejs-lodash-padleft , nodejs-lodash-padright , nodejs-lodash-pairs ,
     nodejs-lodash-parseint , nodejs-lodash-partial , nodejs-lodash-
     partialright , nodejs-lodash-partition , nodejs-lodash-pick , nodejs-
     lodash-pickbyarray , nodejs-lodash-pickbycallback , nodejs-lodash-
     pluck , nodejs-lodash-property , nodejs-lodash-propertyof , nodejs-
     lodash-pull , nodejs-lodash-pullat , nodejs-lodash-random , nodejs-
     lodash-range , nodejs-lodash-rearg , nodejs-lodash-reduce , nodejs-
     lodash-reduceright , nodejs-lodash-reescape , nodejs-lodash-reevaluate
     , nodejs-lodash-reinterpolate , nodejs-lodash-reject , nodejs-lodash-
     remove , nodejs-lodash-repeat , nodejs-lodash-replaceholders , nodejs-
     lodash-rest , nodejs-lodash-restparam , nodejs-lodash-result , nodejs-
     lodash-round , nodejs-lodash-sample , nodejs-lodash-set , nodejs-
     lodash-shuffle , nodejs-lodash-size , nodejs-lodash-slice , nodejs-
     lodash-snakecase , nodejs-lodash-some , nodejs-lodash-sortby , nodejs-
     lodash-sortbyall , nodejs-lodash-sortbyorder , nodejs-lodash-
     sortedindex , nodejs-lodash-sortedlastindex , nodejs-lodash-spread ,
     nodejs-lodash-startcase , nodejs-lodash-startswith , nodejs-lodash-sum
     , nodejs-lodash-support , nodejs-lodash-take , nodejs-lodash-takeright
     , nodejs-lodash-takerightwhile , nodejs-lodash-takewhile , nodejs-
     lodash-template , nodejs-lodash-templatesettings , nodejs-lodash-
     throttle , nodejs-lodash-times , nodejs-lodash-toarray , nodejs-
     lodash-toiterable , nodejs-lodash-topath , nodejs-lodash-toplainobject
     , nodejs-lodash-transform , nodejs-lodash-trim , nodejs-lodash-
     trimleft , nodejs-lodash-trimmedleftindex , nodejs-lodash-
     trimmedrightindex , nodejs-lodash-trimright , nodejs-lodash-trunc ,
     nodejs-lodash-unescape , nodejs-lodash-union , nodejs-lodash-uniq ,
     nodejs-lodash-uniqueid , nodejs-lodash-unzip , nodejs-lodash-unzipwith
     , nodejs-lodash-values , nodejs-lodash-valuesin , nodejs-lodash-where
     , nodejs-lodash-without , nodejs-lodash-words , nodejs-lodash-wrap ,
     nodejs-lodash-xor , nodejs-lodash-zip , nodejs-lodash-zipobject ,
     nodejs-lodash-zipwith


The %{?_isa} part can be ignored because this is a noarch package, but I think you should have to add -%{release}.



[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.


Tests are missing in spec. There are tests but they depend on qunit which we have not packaged yet.



[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
Comment 11 Piotr Popieluch 2015-12-13 07:06:59 EST
Rpmlint
-------
Checking: lodash-3.10.1-1.fc24.noarch.rpm
          js-lodash-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-compat-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-node-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-cli-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-add-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-after-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-arraycopy-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-arrayeach-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-arrayevery-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-arrayfilter-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-arraymap-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-ary-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-assign-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-at-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-attempt-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseassign-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseat-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basecallback-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseclone-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basecompareascending-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basecopy-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basecreate-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basedelay-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basedifference-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseeach-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseeachright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basefilter-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basefind-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basefindindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseflatten-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basefor-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseforright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basefunctions-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseget-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseindexof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseisequal-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseismatch-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basematches-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basematchesproperty-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basepullat-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baserandom-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basereduce-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseslice-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basesortby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basesortbyorder-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basetostring-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-baseuniq-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-basevalues-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-before-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-binaryindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-binaryindexby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-bind-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-bindall-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-bindcallback-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-bindkey-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-cacheindexof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-callback-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-camelcase-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-capitalize-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-ceil-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-charsleftindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-charsrightindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-chunk-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-clone-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-clonedeep-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-compact-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-constant-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-countby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-create-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createaggregator-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createassigner-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createcache-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createcompounder-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createpadding-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-createwrapper-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-curry-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-curryright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-debounce-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-deburr-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-defaults-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-defaultsdeep-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-defer-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-delay-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-difference-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-drop-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-dropright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-droprightwhile-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-dropwhile-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-endswith-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-escape-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-escaperegexp-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-every-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-fill-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-filter-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-find-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findkey-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findlast-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findlastindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findlastkey-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-findwhere-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-first-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-flatten-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-flattendeep-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-floor-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-flow-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-flowright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-foreach-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-foreachright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-forin-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-forinright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-forown-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-forownright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-functions-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-get-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-getnative-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-groupby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-gt-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-gte-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-has-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-identity-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-includes-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-indexby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-indexof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-initial-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-inrange-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-intersection-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-invert-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-invoke-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-invokepath-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isarguments-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isarray-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isboolean-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isdate-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-iselement-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isempty-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isequal-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-iserror-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isfinite-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isfunction-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isiterateecall-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-ismatch-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isnan-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isnative-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isnull-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isnumber-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isobject-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isplainobject-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isregexp-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isstring-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-istypedarray-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-isundefined-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-kebabcase-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-keys-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-keysin-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-last-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-lastindexof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-lt-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-lte-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-map-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-mapkeys-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-mapvalues-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-matches-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-matchesproperty-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-max-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-memoize-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-merge-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-method-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-methodof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-min-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-mixin-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-modargs-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-negate-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-noop-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-now-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-omit-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-once-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pad-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-padleft-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-padright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pairs-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-parseint-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-partial-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-partialright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-partition-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pick-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pickbyarray-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pickbycallback-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pluck-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-property-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-propertyof-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pull-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-pullat-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-random-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-range-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-rearg-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reduce-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reduceright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reescape-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reevaluate-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reinterpolate-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-reject-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-remove-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-repeat-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-replaceholders-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-rest-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-restparam-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-result-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-round-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sample-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-set-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-shuffle-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-size-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-slice-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-snakecase-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-some-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sortby-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sortbyall-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sortbyorder-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sortedindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sortedlastindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-spread-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-startcase-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-startswith-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-sum-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-support-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-take-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-takeright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-takerightwhile-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-takewhile-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-template-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-templatesettings-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-throttle-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-times-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-toarray-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-toiterable-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-topath-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-toplainobject-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-transform-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trim-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trimleft-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trimmedleftindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trimmedrightindex-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trimright-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-trunc-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-unescape-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-union-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-uniq-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-uniqueid-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-unzip-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-unzipwith-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-values-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-valuesin-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-where-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-without-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-words-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-wrap-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-xor-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-zip-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-zipobject-3.10.1-1.fc24.noarch.rpm
          nodejs-lodash-zipwith-3.10.1-1.fc24.noarch.rpm
          lodash-3.10.1-1.fc24.src.rpm
lodash.noarch: W: spelling-error %description -l en_US modularity -> molecularity
lodash.noarch: W: obsolete-not-provided nodejs-lodash-arraypool
lodash.noarch: W: obsolete-not-provided nodejs-lodash-basebind
lodash.noarch: W: obsolete-not-provided nodejs-lodash-basecreatecallback
lodash.noarch: W: obsolete-not-provided nodejs-lodash-basecreatewrapper
lodash.noarch: W: obsolete-not-provided nodejs-lodash-basemerge
lodash.noarch: W: obsolete-not-provided nodejs-lodash-cachepush
lodash.noarch: W: obsolete-not-provided nodejs-lodash-charatcallback
lodash.noarch: W: obsolete-not-provided nodejs-lodash-compareascending
lodash.noarch: W: obsolete-not-provided nodejs-lodash-compose
lodash.noarch: W: obsolete-not-provided nodejs-lodash-contains
lodash.noarch: W: obsolete-not-provided nodejs-lodash-createcallback
lodash.noarch: W: obsolete-not-provided nodejs-lodash-escapehtmlchar
lodash.noarch: W: obsolete-not-provided nodejs-lodash-escapestringchar
lodash.noarch: W: obsolete-not-provided nodejs-lodash-getarray
lodash.noarch: W: obsolete-not-provided nodejs-lodash-getobject
lodash.noarch: W: obsolete-not-provided nodejs-lodash-htmlescapes
lodash.noarch: W: obsolete-not-provided nodejs-lodash-htmlunescapes
lodash.noarch: W: obsolete-not-provided nodejs-lodash-keyprefix
lodash.noarch: W: obsolete-not-provided nodejs-lodash-largearraysize
lodash.noarch: W: obsolete-not-provided nodejs-lodash-lodashwrapper
lodash.noarch: W: obsolete-not-provided nodejs-lodash-maxpoolsize
lodash.noarch: W: obsolete-not-provided nodejs-lodash-objectpool
lodash.noarch: W: obsolete-not-provided nodejs-lodash-objecttypes
lodash.noarch: W: obsolete-not-provided nodejs-lodash-reescapedhtml
lodash.noarch: W: obsolete-not-provided nodejs-lodash-releasearray
lodash.noarch: W: obsolete-not-provided nodejs-lodash-releaseobject
lodash.noarch: W: obsolete-not-provided nodejs-lodash-reunescapedhtml
lodash.noarch: W: obsolete-not-provided nodejs-lodash-setbinddata
lodash.noarch: W: obsolete-not-provided nodejs-lodash-shimisplainobject
lodash.noarch: W: obsolete-not-provided nodejs-lodash-shimkeys
lodash.noarch: W: obsolete-not-provided nodejs-lodash-unescapehtmlchar


This is interesting, what happened with those modules, are they deprecated in lodash?
I think the obsoletes for these modules must be removed
Comment 12 Piotr Popieluch 2015-12-13 07:11:01 EST
Source checksums
----------------
https://github.com/lodash/lodash/archive/3.10.1/lodash-3.10.1.tar.gz :
  CHECKSUM(SHA256) this package     : 0e88207e5f90af4ce8790d6e1e7d09d2702d81bce0bafdc253d18c0a5bf7661e
  CHECKSUM(SHA256) upstream package : 0e88207e5f90af4ce8790d6e1e7d09d2702d81bce0bafdc253d18c0a5bf7661e
https://github.com/lodash/lodash-cli/archive/3.10.1/lodash-cli-3.10.1.tar.gz :
  CHECKSUM(SHA256) this package     : 9cb0b8a5744c8477518198b97a6070fd3c242f539b4d6044462d689569aa793a
  CHECKSUM(SHA256) upstream package : 9cb0b8a5744c8477518198b97a6070fd3c242f539b4d6044462d689569aa793a


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1288858
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6



I had no more comments, uploaded full review.txt here: https://piotrp.fedorapeople.org/lodash/review.txt
Comment 13 Tom Hughes 2015-12-13 07:23:21 EST
I believe all those modules require the base lodash package, which includes the license. Maybe the missing release on the require is making it complain there?

I've added the release to the modules which are requiring the base package now.

It's also complaining about the packages for the individual functions not requiring the base package, but I don't think they actually need to as they have their own license file?

As to the obsoletes, those are all functions which no longer exist in lodash. Because it is exporting each individual function (including some internal ones that start with an underscore) as a separate module when functions are removed they need to be obsoleted but I don't see how we can claim to provide them?
Comment 14 Tom Hughes 2015-12-13 07:47:04 EST
I guess per https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages the situation with the removed functions comes under "If a package supersedes/replaces an existing package without being a compatible enough replacement as defined in above, use only the Obsoletes from above."?
Comment 15 Tom Hughes 2015-12-13 12:17:28 EST
Tests require qunit by the way, which isn't currently available, and I can't actually get them to run even if I install it locally, for reasons which are not entirely clear...
Comment 16 Tom Hughes 2015-12-13 12:28:40 EST
New version with fully versioned requires:

Spec URL: http://tomh.fedorapeople.org//lodash.spec
SRPM URL: http://tomh.fedorapeople.org//lodash-3.10.1-2.fc23.src.rpm
Comment 17 Piotr Popieluch 2015-12-14 13:23:14 EST
I've taken another look and think everything is ok then.
Comment 18 Tom Hughes 2015-12-14 14:01:35 EST
Thanks a lot! I know this wasn't an easy one...
Comment 19 Gwyn Ciesla 2015-12-14 14:38:25 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/lodash

Note You need to log in before you can comment on or make changes to this bug.